# PyTorch 自然语言处理（Natural Language Processing with PyTorch 中文版）

![](https://nlp-pt.apachecn.org/cover.jpg)

> 译者：[Yif Du](https://yifdu.github.io/)
> 
> 协议：[CC BY-NC-ND 4.0](https://creativecommons.org/licenses/by-nc-nd/4.0/)
> 
> 欢迎任何人参与和完善：一个人可以走的很快，但是一群人却可以走的更远。

本书旨在为新人提供自然语言处理（NLP）和深度学习，以涵盖这两个领域的重要主题。这两个主题领域都呈指数级增长。对于一本介绍深度学习和强调实施的NLP的书，本书占据了重要的中间地带。在写这本书时，我们不得不对哪些材料遗漏做出艰难的，有时甚至是不舒服的选择。对于初学者，我们希望本书能够为基础知识提供强有力的基础，并可以瞥见可能的内容。特别是机器学习和深度学习是一种经验学科，而不是智力科学。我们希望每章中慷慨的端到端代码示例邀请您参与这一经历。当我们开始编写本书时，我们从PyTorch 0.2开始。每个PyTorch更新从0.2到0.4修改了示例。 PyTorch 1.0将于本书出版时发布。本书中的代码示例符合PyTorch 0.4，它应该与即将发布的PyTorch 1.0版本一样工作.1关于本书风格的注释。我们在大多数地方都故意避免使用数学;并不是因为深度学习数学特别困难（事实并非如此），而是因为它在许多情况下分散了本书主要目标的注意力——增强初学者的能力。在许多情况下，无论是在代码还是文本方面，我们都有类似的动机，我们倾向于对简洁性进行阐述。高级读者和有经验的程序员可以找到方法来收紧代码等等，但我们的选择是尽可能明确，以便覆盖我们想要达到的大多数受众。

* [在线阅读](https://nlp-pt.apachecn.org)
* [代码地址](https://github.com/joosthub/PyTorchNLPBook)
* **ApacheCN - 面试求职群【724187166】<a target="_blank" href="//shang.qq.com/wpa/qunwpa?idkey=9bcf2fb3985835c9c2f15783ec9c85822e23be1191a6581eaf22f574b5192b19"><img border="0" src="http://data.apachecn.org/img/logo/ApacheCN-group.png" alt="ApacheCN - 面试求职群[724187166]" title="ApacheCN - 面试求职群[724187166]"></a>**
* [ApacheCN 学习资源](http://www.apachecn.org/)
* 电子书下载地址：[epub](https://github.com/apachecn/pytorch-doc-zh/tree/gh-pages/books/nlp-pytorch-zh.epub), [mobi](https://github.com/apachecn/pytorch-doc-zh/tree/gh-pages/books/nlp-pytorch-zh.mobi)
    * 我这边编译失败，请各位小哥哥自行手动编译
    * mkdir books
    * gitbook epub . books/nlp-pytorch-zh.epub
    * gitbook mobi . books/nlp-pytorch-zh.mobi

## 目录

* [Chapter 1.基础介绍](docs/1.md)
* [Chapter 2.传统NLP快速回顾](docs/2.md)
* [Chapter 3.神经网络基础组件](docs/3.md)
* [Chapter 4.自然语言处理 Feed-Forward Networks](docs/4.md)
* [Chapter 5.Embedding Words and Types](docs/5.md)
* [Chapter 6.自然语言处理 Sequence Modeling](docs/6.md)
* [Chapter 7.自然语言处理的中间 Sequence Modeling](docs/7.md)
* [Chapter 8.用于自然语言处理的高级 Sequence](docs/8.md)
* [Chapter 9.经典, 前沿和后续步骤](docs/9.md)

## 精品推荐

> Pytorch 中文文档&中文教程

* Pytorch 中文教程: <https://pytorch.apachecn.org>

> 深度学习必学

1. [反向传递](/docs/dl/反向传递.md): <https://www.cnblogs.com/charlotte77/p/5629865.html>
2. [CNN原理](/docs/dl/CNN原理.md): <http://www.cnblogs.com/charlotte77/p/7759802.html>
3. [RNN原理](/docs/dl/RNN原理.md): <https://blog.csdn.net/qq_39422642/article/details/78676567>
4. [LSTM原理](/docs/dl/LSTM原理.md): <https://blog.csdn.net/weixin_42111770/article/details/80900575>

> 自然语言处理

* Python 自然语言处理 第二版: <https://usyiyi.github.io/nlp-py-2e-zh>
* 推荐一个[liuhuanyong大佬](https://github.com/liuhuanyong)整理的nlp全面知识体系: <https://liuhuanyong.github.io>
* 开源 - 词向量库集合: 
  * <https://github.com/Embedding/Chinese-Word-Vectors>
  * <https://github.com/brightmart/nlp_chinese_corpus>
  * <https://github.com/codemayq/chinese_chatbot_corpus>
  * <https://github.com/candlewill/Dialog_Corpus>
* 新词发现代码 python 实现: <https://github.com/zhanzecheng/Chinese_segment_augment>
* 电影知识图谱 python 实现: <https://github.com/SimmerChan/KG-demo-for-movie>
* 知识图谱的《红楼梦》人物关系可视化及问答系统 python 实现: <https://github.com/chizhu/KGQA_HLM>

## 关于转载

* 禁止商业化，符合协议规范，备注地址来源，不需要发邮件给我们申请【如果觉得有帮助，欢迎各位踊跃收藏和转载】
